package applet;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.JApplet;
import javax.swing.JButton;

import ejbs.samplesession.SampleSession;
import ejbs.samplesession.SampleSessionHome;

public class EJBApplet extends JApplet {
	private JButton button = null;

	//-----------------------------[ Listing 1.17 ]------------------------------------//
	public EJBApplet() {
	}

	public void init() {
		setSize(new Dimension(400, 100));

		button = new JButton("Start");

		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				//callEJB();
			}
		});

		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(button, BorderLayout.CENTER);
	}

	public void callEJB() {
		try {
			InitialContext ctx = getInitialContext();

			SampleSessionHome home =
				(SampleSessionHome) PortableRemoteObject.narrow(ctx.lookup("ejb/sampleSession"), SampleSessionHome.class);

			SampleSession bean = home.create();
			bean.doProcess();

		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	private InitialContext getInitialContext() throws Exception {
		Properties props = new Properties();

		String theHost = getCodeBase().getHost();
		props.setProperty(Context.PROVIDER_URL, theHost + ":7001");
		props.setProperty(Context.INITIAL_CONTEXT_FACTORY, "weblogic.jndi.WLInitialContextFactory");

		return new InitialContext(props);
	}
	//-----------------------------[ Listing 1.17 ]------------------------------------//

}
