package tests.ejbpersistence;

import java.io.FileInputStream;
import java.io.ObjectInputStream;

import javax.ejb.Handle;
import javax.rmi.PortableRemoteObject;

import ejbs.equity.EquityVO;
import ejbs.samecontainer.Helper;

public class ClientLoader {

	//---------------------------[ Listing 1.13 ]----------------------------------------//
	public void runExample() {
		Helper goodHelper = null;

		goodHelper = loadReference();

		try {

			log("---------[ Helper ]------------");
			EquityVO equity = goodHelper.getEquity("ITWO");
			log(equity.toString());
			log("---------[ Helper ]------------");

		}
		catch (Exception e) {
			log("Error creating Helper: ");
			e.printStackTrace();
			System.exit(1);
		}
	}
	

	private Helper loadReference() {
		FileInputStream istream = null;
		ObjectInputStream objStream = null;
		Handle handle = null;
		Helper helper = null;

		try {

			istream = new FileInputStream("Helper.obj");
			objStream = new ObjectInputStream(istream);

			Object o = objStream.readObject();

			handle = (Handle) objStream.readObject();
			objStream.close();

			helper = (Helper) PortableRemoteObject.narrow(handle.getEJBObject(), Helper.class);
		}
		catch (Exception e) {
			e.printStackTrace();
		}

		return helper;
	}
	//---------------------------[ Listing 1.13 ]----------------------------------------//

	private static void log(String s) {
		System.out.println(s);
	}

	public static void main(String[] args) {
		String url = "t3://localhost:7001";
		ClientLoader client = null;

		System.out.println("\nBeginning ejbPersistence.ClientLoader...\n");

		try {
			client = new ClientLoader();
		}
		catch (Exception ne) {
			log("Unable to look up the beans home: " + ne.getMessage());
			System.exit(1);
		}

		try {
			client.runExample();
		}
		catch (Exception e) {
			log("There was an exception while creating and using the Helper.");
			log("This indicates that there was a problem communicating with the server: " + e);
		}

		System.out.println("\nEnd ejbPersistence.ClientLoader...\n");
	}

}
