package ejbs.CMPsequence;

import javax.ejb.CreateException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

abstract public class SequenceBean implements EntityBean {

	//------------------------------------------------------------------------------------------------------

	private EntityContext ctx;

	public SequenceBean() {
	};

	public void setEntityContext(EntityContext ctx) {
		log("setEntityContext called (" + id() + ")");
		this.ctx = ctx;
	}

	public void unsetEntityContext() {
		log("SequenceBean.unsetEntityContext (" + id() + ")");
		this.ctx = null;
	}

	abstract public String getName();
	abstract public void setName(String val);

    //----------------------------[ Listing CMP Sequence ]------------------------------------//
	abstract public Integer getSequenceId();
	abstract public void setSequenceId(Integer val);
	//----------------------------[ Listing CMP Sequence ]------------------------------------//

	private String id() {
		return ""
			+ System.identityHashCode(this)
			+ ", PK = "
			+ (String) ((ctx == null)
				? "nullctx"
				: ((ctx.getPrimaryKey() == null ? "null" : ctx.getPrimaryKey().toString())));
	}

	public void ejbActivate() {
		log("SequenceBean.ejbActivate (" + id() + ")");
	}

	public void ejbPassivate() {
		log("SequenceBean.ejbPassivate (" + id() + ")");
	}

	public void ejbLoad() {
		log("SequenceBean.ejbLoad (" + id() + ")");
	}

	public void ejbStore() {
		log("SequenceBean.ejbStore (" + id() + ")");
	}

	public void ejbRemove() throws RemoveException {
		log("SequenceBean.ejbRemove (" + id() + ")");
	}

	public Integer ejbCreate(String name) throws CreateException {
		setName(name);

		return null; // See 9.4.2 of the EJB 1.1 specification
	}

	public void ejbPostCreate(String name) {
		log("SequenceBean.ejbPostCreate");
	}

	// You might also consider using WebLogic's log service
	private void log(String s) {
		System.out.println(s);
	}

}
