package ejbs.one2onerelation;


import javax.ejb.CreateException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

abstract public class AddressBean implements EntityBean {
  private EntityContext               ctx;

  public AddressBean() {}

  public void setEntityContext(EntityContext ctx) {
    log("setEntityContext called (" + id() + ")");
    this.ctx = ctx;
  }

  public void unsetEntityContext() {
    log("unsetEntityContext (" + id() + ")");
    this.ctx = null;
  }

  //-------------------[ Listing 3.14 ]-----------------//
  abstract public String getAddressField();
  abstract public void   setAddressField(String val);
  abstract public Owner  getOwner();
  abstract public void   setOwner(Owner owner);
  //-------------------[ Listing 3.14 ]-----------------//


  private String id() {
    return ""+System.identityHashCode(this)+", PK="+
           (String) ((ctx == null) ? "nullctx"
                 : ((ctx.getPrimaryKey() == null ?
                   "null" : ctx.getPrimaryKey().toString())));
  }

  public void ejbActivate() {
      log("ejbActivate (" + id() + ")");
  }

  public void ejbPassivate() {
    log("ejbPassivate (" + id() + ")");
  }

  public void ejbLoad() {
    log("ejbLoad (" + id() +  ")");
  }

  public void ejbStore() {
    log("ejbStore (" + id() + ")");
  }

  public void ejbRemove() throws RemoveException{
    log("ejbRemove (" + id() + ")");
  }

  public String ejbCreate(String address)throws CreateException{
    log("ejbCreate( id="+System.identityHashCode(this)+", PK="+address);

    setAddressField(address);

    return null;
  }

  public void ejbPostCreate(String address)throws CreateException{
    log("ejbPostCreate (" + id() + ")");
  }


  private void log(String s) {
    System.out.println("AddressBean::"+s);
  }

}











