package ejbs.one2onerelation;

import javax.ejb.CreateException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

abstract public class OwnerBean implements EntityBean {
	private EntityContext ctx;

	public OwnerBean() {
	}

	public void setEntityContext(EntityContext ctx) {
		log("setEntityContext called (" + id() + ")");
		this.ctx = ctx;
	}

	public void unsetEntityContext() {
		log("unsetEntityContext (" + id() + ")");
		this.ctx = null;
	}

	//-------------------[ Listing 3.13 ]-----------------//
	abstract public java.lang.String getOwnerName();
	abstract public void setOwnerName(java.lang.String val);
	abstract public java.sql.Date getLastAccess();
	abstract public void setLastAccess(java.sql.Date val);
	abstract public Address getAddress();
	abstract public void setAddress(Address address);
	//-------------------[ Listing 3.13 ]-----------------//

	private String id() {
		return ""
			+ System.identityHashCode(this)
			+ ", PK = "
			+ (String) ((ctx == null)
				? "nullctx"
				: ((ctx.getPrimaryKey() == null ? "null" : ctx.getPrimaryKey().toString())));
	}

	public void ejbActivate() {
		log("ejbActivate (" + id() + ")");
	}

	public void ejbPassivate() {
		log("ejbPassivate (" + id() + ")");
	}

	public void ejbLoad() {
		log("ejbLoad (" + id() + ")");
	}

	public void ejbStore() {
		log("ejbStore (" + id() + ")");
	}

	public void ejbRemove() throws RemoveException {
		log("ejbRemove (" + id() + ")");
	}

	public String ejbCreate(String name, java.sql.Date lastAccess) throws CreateException {
		log("ejbCreate( id = " + System.identityHashCode(this) + ", PK=" + name + ")");

		setOwnerName(name);
		setLastAccess(lastAccess);

		return null; // See 9.4.2 of the EJB 1.1 specification
	}

	public void ejbPostCreate(String name, java.sql.Date lastAccess) throws CreateException {
		log("ejbPostCreate (" + id() + ")");
	}

	private void log(String s) {
		System.out.println("OwnerBean::" + s);
	}
}
