package ejbs.sessionFacade;
import javax.ejb.CreateException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

abstract public class PasswordBean implements EntityBean {
	private EntityContext ctx;

	public PasswordBean() {
	}

	public void setEntityContext(EntityContext ctx) {
		log("setEntityContext called (" + id() + ")");
		this.ctx = ctx;
	}

	public void unsetEntityContext() {
		log("unsetEntityContext (" + id() + ")");
		this.ctx = null;
	}

	abstract public java.lang.String getUserName();
	abstract public void setUserName(java.lang.String val);
	abstract public java.lang.String getPassword();
	abstract public void setPassword(java.lang.String val);
	abstract public java.sql.Date getLastAccess();
	abstract public void setLastAccess(java.sql.Date val);

	public boolean isPasswordValid(String password) {
		String passwd = getPassword();
		log("isPasswordValid Method Called");

		return password.equals(passwd);
	}

	private String id() {
		return ""
			+ System.identityHashCode(this)
			+ ", PK = "
			+ (String) ((ctx == null)
				? "nullctx"
				: ((ctx.getPrimaryKey() == null ? "null" : ctx.getPrimaryKey().toString())));
	}

	public void ejbActivate() {
		log("ejbActivate (" + id() + ")");
	}

	public void ejbPassivate() {
		log("ejbPassivate (" + id() + ")");
	}

	public void ejbLoad() {
		log("ejbLoad (" + id() + ")");
	}

	public void ejbStore() {
		log("ejbStore (" + id() + ")");
	}

	public void ejbRemove() throws RemoveException {
		log("ejbRemove (" + id() + ")");
	}

	public String ejbCreate(String userName, String passwd) throws CreateException {
		log("ejbCreate( id = " + System.identityHashCode(this) + ", PK=" + userName + ")");

		setUserName(userName);
		setPassword(passwd);
		setLastAccess(new java.sql.Date(System.currentTimeMillis()));

		return null;
	}

	public void ejbPostCreate(String userName, String password) throws CreateException {
		log("ejbPostCreate (" + id() + ")");
	}

	private void log(String s) {
		System.out.println("PasswordBean::" + s);
	}
}
