package ejbs.userspecificdb;

import javax.ejb.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.sql.*;
import java.util.*;
import java.security.Principal;

public class UserSpecificDBBean implements SessionBean {

	//--------------------------[ Listing 3.5 ]------------------------------------------------//
	private SessionContext ctx;

	public void setSessionContext(SessionContext ctx) {
		this.ctx = ctx;
	}

	public Connection getConnection() throws SQLException {
		String srcName = null;
		InitialContext initCtx = null;

		try {
			Principal p = this.ctx.getCallerPrincipal();
			String username = p.getName();

			initCtx = new InitialContext();
			System.out.println("User Requesting Connection:" + username);

			srcName = "java:comp/env/" + username + "BookDataSource";
			System.out.println("User Requesting DataSource:" + srcName);

			return ((javax.sql.DataSource) initCtx.lookup(srcName)).getConnection();
		}
		catch (NamingException ne) {
			ne.printStackTrace();
			throw new EJBException(ne);
		}
		finally {
			try {
				if (initCtx != null)
					initCtx.close();
			}
			catch (NamingException ne) {
				throw new EJBException(ne);
			}
		} //finally
	} //method

	//--------------------------[ Listing 3.5 ]------------------------------------------------//

	private void log(String s) {
		System.out.println(s);
	}

	public void ejbActivate() {
		log("ejbActivate called");
	}

	public void ejbRemove() {
		log("ejbRemove called");
	}

	public void ejbPassivate() {
		log("ejbPassivate called");
	}

	public void ejbCreate() throws CreateException {
		log("ejbCreate called");
	}

	public Vector getAllSymbols() {
		PreparedStatement ps = null;
		Connection con = null;
		Vector vector = new Vector();
		ResultSet rs = null;

		try {
			con = getConnection();

			String query = "select symbol from Equities";
			log("Executing Query:" + query);

			ps = con.prepareStatement(query);
			ps.executeQuery();

			rs = ps.getResultSet();
			while (rs.next()) {
				vector.add(rs.getString(1));
			}
		}
		catch (Exception sqe) {
			log("SQLException:  " + sqe);
			throw new EJBException(sqe);
		}
		finally {
			try {
				if (rs != null)
					rs.close();
				if (ps != null)
					ps.close();
				if (con != null)
					con.close();
			}
			catch (SQLException e) {
			}
		}

		return vector;

	}

}
