package ejbs.view;

import java.rmi.RemoteException;

import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;


abstract public class EquityBean implements EntityBean {
  private EntityContext               ctx;

  public EquityBean() {};

  public void setEntityContext(EntityContext ctx) {
    log("setEntityContext called (" + id() + ")");
    this.ctx = ctx;
  }

  public void unsetEntityContext() {
    log("EquityBean.unsetEntityContext (" + id() + ")");
    this.ctx = null;
  }

  abstract public String getSymbol();
  abstract public void setSymbol(String symbol);

  abstract public String getDescription();
  abstract public void setDescription(String description);

  abstract public double getLastTrade();
  abstract public void setLastTrade(double lastTrade);

  private String id() {
    return "" + System.identityHashCode(this) + ", PK = " + 
      (String) ((ctx == null) ? "nullctx" 
                 : ((ctx.getPrimaryKey() == null ?
                   "null" : ctx.getPrimaryKey().toString())));
  }

  public void ejbActivate() {
      log("EquityBean.ejbActivate (" + id() + ")");
  }

  public void ejbPassivate() {
    log("EquityBean.ejbPassivate (" + id() + ")");
  }

  public void ejbLoad() {
    log("EquityBean.ejbLoad (" + id() +  ")");
  }

  public void ejbStore() {
    log("EquityBean.ejbStore (" + id() + ")");
  }

  public void ejbRemove()
    throws RemoveException
  {
    log("EquityBean.ejbRemove (" + id() + ")");
  }


  // Application defined methods

  public void log(String logstr){
    System.out.println(logstr);
  }

  public void setEquity(EquityVO equity)throws RemoteException{
    setDescription(equity.description);
    setLastTrade(equity.lastTrade);
  }

  public EquityVO getEquity()throws RemoteException{
    EquityVO               equity=new EquityVO();

    equity.symbol=getSymbol();
    equity.description=getDescription();
    equity.lastTrade=getLastTrade();

    return equity;
  }


}











