package ejbs.asyncSession;

import javax.ejb.CreateException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

public class MessageBean implements MessageDrivenBean, MessageListener {
	private MessageDrivenContext ctx;
	private int m_tradeLimit;

	public void ejbRemove() {
		log("ejbRemove called");
	}

	public void ejbPassivate() {
		log("ejbPassivate called");
	}

	public void setMessageDrivenContext(MessageDrivenContext ctx) {
		log("setMessageDrivenContext called");
		this.ctx = ctx;
	}

	public void ejbCreate() throws CreateException {
		log("ejbCreate called - This is called by the Container when deploying bean");

	}

	public void onMessage(Message msg) {
		MapMessage map = (MapMessage) msg;

		try {
			String processId = map.getString("ProcessId");

			log("Received processId : " + processId);
			try {
				Thread.sleep(10000);
			}
			catch (InterruptedException e) {
			}
			updateStatus(processId);
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void updateStatus(String processId) {
		int status = 1;
		Context ctx = null;
		StatusHome home = null;
		Status statusBean = null;

		try {
			ctx = new InitialContext();
			log("Looking up Home:statusHome");
			home = (StatusHome) ctx.lookup("statusHome");
			home = (StatusHome) PortableRemoteObject.narrow(home, StatusHome.class);
			statusBean = (Status) PortableRemoteObject.narrow(home.findByPrimaryKey(processId), Status.class);
			log("Updating Status for process:" + processId);
			statusBean.setStatus(status);
			log("Status Now:" + statusBean.getStatus() + " For ProcessId:" + processId);
		}
		catch (Exception e) {
			e.printStackTrace();
			log(
				"The client was unable to lookup the EJBHome.  Please make sure "
					+ "that you have deployed the ejb with the JNDI name "
					+ "statusHome on the WebLogic server");
		}
	}

	private void log(String s) {
		System.out.println(s);
	}

	public void ejbActivate() {
		log("ejbActivate called");
	}

}
