package ejbs.asyncSession;

import javax.ejb.CreateException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

abstract public class StatusBean implements EntityBean {
	private EntityContext ctx;

	public StatusBean() {
	};

	public void setEntityContext(EntityContext ctx) {
		log("setEntityContext called (" + id() + ")");
		this.ctx = ctx;
	}

	public void unsetEntityContext() {
		log("StatusBean.unsetEntityContext (" + id() + ")");
		this.ctx = null;
	}

	abstract public int getStatus();
	abstract public void setStatus(int status);

	abstract public String getProcessId();
	abstract public void setProcessId(String processId);

	private String id() {
		return ""
			+ System.identityHashCode(this)
			+ ", PK = "
			+ (String) ((ctx == null)
				? "nullctx"
				: ((ctx.getPrimaryKey() == null ? "null" : ctx.getPrimaryKey().toString())));
	}

	public void ejbActivate() {
		log("StatusBean.ejbActivate (" + id() + ")");
	}

	public void ejbPassivate() {
		log("StatusBean.ejbPassivate (" + id() + ")");
	}

	public void ejbLoad() {
		log("StatusBean.ejbLoad (" + id() + ")");
	}

	public void ejbStore() {
		log("StatusBean.ejbStore (" + id() + ")");
	}

	public void ejbRemove() throws RemoveException {
		log("StatusBean.ejbRemove (" + id() + ")");
	}

	public String ejbCreate(String processId, int status) throws CreateException {
		log(
			"StatusBean.ejbCreate( id = "
				+ System.identityHashCode(this)
				+ ", PK = "
				+ processId
				+ ", "
				+ "Status =  "
				+ status
				+ ")");

		setProcessId(processId);
		setStatus(status);

		return null; // See 9.4.2 of the EJB 1.1 specification
	}

	public void ejbPostCreate(String processId, int status) {
		log("StatusBean.ejbPostCreate (" + id() + ")");
	}

	// Application defined methods

	public void log(String logstr) {
		System.out.println(logstr);
	}

}
