package ejbs.fileAccess;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.ejb.CreateException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.Context;
import javax.naming.InitialContext;

public class FileAccessBean implements SessionBean {

	private SessionContext ctx;
	private String classname = null;

	private void log(String s) {
		System.out.println("FileAccessBean::" + s);
	}

	public void ejbActivate() {
		log("ejbActivate called");
	}

	public void ejbRemove() {
		log("ejbRemove called");
	}

	public void ejbPassivate() {
		log("ejbPassivate called");
	}

	public void setSessionContext(SessionContext ctx) {
		log("setSessionContext called");
		this.ctx = ctx;
	}

	public void ejbCreate() throws CreateException {
		log("ejbCreate called");
	}

	public void createFile(String filename, String data) throws IOException {
		OutputStream ostream = null;
		FileUtilInterface client = null;

		try {
			System.out.println("Creating File:" + filename);
			client = getUtilClass();
			ostream = client.getFileOutputStream(filename);
			ostream.write(data.getBytes());
			ostream.close();
		}
		catch (Exception e) {
			e.printStackTrace();
		}

		log("Creating file:" + filename);
		log("------[ Data ]---------\n" + data);
		log("------[ Data ]---------\n");
	}

	public void deleteFile(String filename) throws IOException {
		FileUtilInterface client = null;

		log("Deleting file:" + filename);
		client = getUtilClass();
		client.delete(filename);
	}

	public String readFile(String filename) throws IOException {
		String data = null;
		FileUtilInterface client = null;
		byte[] bytes = new byte[1024];
		int bytesRead = 0;
		StringBuffer buffer = new StringBuffer();
		InputStream istream = null;

		try {
			log("Reading file:" + filename);
			client = getUtilClass();
			istream = client.getFileInputStream(filename);
			while ((bytesRead = istream.read(bytes, 0, 1024)) >= 0) {
				buffer.append(new String(bytes, 0, bytesRead));
			}
			istream.close();
			data = buffer.toString();
			System.out.println("File contents: " + data);

		}
		catch (Exception e) {
			e.printStackTrace();
		}

		log("------[ Data ]---------\n" + data);
		log("------[ Data ]---------\n");

		return data;
	}

	private FileUtilInterface getUtilClass() {
		FileUtilInterface client = null;
		Class c = null;

		try {
			Context context = new InitialContext();
			classname = (String) context.lookup("java:comp/env/FILE_ACCESS_CLASS");
			log("Using Class:" + classname + " to access Files");
			c = Class.forName(classname);
			client = (FileUtilInterface) c.newInstance();
		}
		catch (Exception e) {
			e.printStackTrace();
		}

		return client;
	}

}
