package ejbs.methodRedux;

import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;
import javax.naming.InitialContext;

abstract public class EntityBeanTemplate implements EntityBean {
	protected EntityContext eContext = null;
	;
	protected InitialContext iContext = null;

	public EntityBeanTemplate() {
	};

	public void setEntityContext(EntityContext eContext) {
		log(this.getClass().getName() + ".setEntityContext (" + id() + ")");
		this.eContext = eContext;
	}

	public void unsetEntityContext() {
		log(this.getClass().getName() + ".unsetEntityContext (" + id() + ")");
		this.eContext = null;
	}

	protected String id() {
		return ""
			+ System.identityHashCode(this)
			+ ", PK = "
			+ (String) ((eContext == null)
				? "nulleContext"
				: ((eContext.getPrimaryKey() == null ? "null" : eContext.getPrimaryKey().toString())));
	}

	public void ejbActivate() {
		log(this.getClass().getName() + ".ejbActivate (" + id() + ")");
	}

	public void ejbPassivate() {
		log(this.getClass().getName() + ".ejbPassivate (" + id() + ")");
	}

	public void ejbLoad() {
		log(this.getClass().getName() + ".ejbLoad (" + id() + ")");
	}

	public void ejbStore() {
		log(this.getClass().getName() + ".ejbStore (" + id() + ")");
	}

	public void ejbRemove() throws RemoveException {
		log(this.getClass().getName() + ".ejbRemove (" + id() + ")");
	}

	protected void log(String s) {
		System.out.println(this.getClass().getName() + "::" + s);
	}

}
