package ejbs.methodRedux;

import javax.ejb.CreateException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.Message;
import javax.jms.MessageListener;

public class MessageBeanTemplate implements MessageDrivenBean, MessageListener {
	private MessageDrivenContext mContext;

	public void ejbRemove() {
		log("ejbRemove called");
	}

	public void ejbPassivate() {
		log("ejbPassivate called");
	}

	public void setMessageDrivenContext(MessageDrivenContext ctx) {
		log("setMessageDrivenContext called");
		this.mContext = ctx;
	}

	public void ejbCreate() throws CreateException {
		log("ejbCreate called - This is called by Container when deploying bean");
	}

	public void ejbActivate() {
		log("ejbActivate called");
	}

	public void log(String s) {
		System.out.println(this.getClass().getName() + "::" + s);
	}

	public void onMessage(Message msg) {
		log("onMessage called");
	}

}
