package ejbs.fifo;

import javax.ejb.CreateException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;



public class MessageBean implements MessageDrivenBean, MessageListener {
  private MessageDrivenContext          ctx;

  public void ejbRemove() {
    log("ejbRemove called");
  }

  public void ejbPassivate() {
    log("ejbPassivate called");
  }

  public void setMessageDrivenContext(MessageDrivenContext ctx) {
    log("setMessageDrivenContext called");
    this.ctx = ctx;
  }

  public void ejbCreate () throws CreateException {
    log("ejbCreate called - This is called by the Container when deploying bean");

  }

  public void onMessage(Message msg) {
    MapMessage map=(MapMessage)msg;

    try {
      int              index=map.getInt("Index");

      log("Received index : " + index+" Thread: "+Thread.currentThread().getName()+" Handling Request");
      try{Thread.sleep(2000);}
      catch(InterruptedException e){
        log("Thread: "+Thread.currentThread().getName()+" Completed Handling Request");
      }
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  private void log(String s) {
    System.out.println(s);
  } 
  
  public void ejbActivate() {
    log("ejbActivate called");
  }

}


