package ejbs.multiSubscriber;

import javax.ejb.CreateException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;

public class MessageBean implements MessageDrivenBean, MessageListener {
	private MessageDrivenContext ctx;
	private int m_tradeLimit;

	public void ejbRemove() {
		log("ejbRemove called");
	}

	public void ejbPassivate() {
		log("ejbPassivate called");
	}

	public void setMessageDrivenContext(MessageDrivenContext ctx) {
		log("setMessageDrivenContext called");
		this.ctx = ctx;
	}

	public void ejbCreate() throws CreateException {
		log("ejbCreate called - This is called by the Container when deploying bean");

	}

	public void onMessage(Message msg) {
		MapMessage map = (MapMessage) msg;

		try {
			String symbol = map.getString("Symbol");
			String description = map.getString("Description");

			log(
				"Received Symbol : "
					+ symbol
					+ "  "
					+ description
					+ "    Thread: "
					+ Thread.currentThread().getName()
					+ " Handling Request");
			try {
				Thread.sleep(10000);
			}
			catch (InterruptedException e) {
				log("Thread: " + Thread.currentThread().getName() + " Completed Handling Request");
			}
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}

	}

	private void log(String s) {
		System.out.println("MessageBean1::" + s);
	}

	public void ejbActivate() {
		log("ejbActivate called");
	}

}
