package ejbs.streamMessage;

import javax.ejb.CreateException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.BytesMessage;
import javax.jms.Message;
import javax.jms.MessageListener;

public class MessageBean implements MessageDrivenBean, MessageListener {
	private MessageDrivenContext ctx;

	public void ejbRemove() {
		log("ejbRemove called");
	}

	public void ejbPassivate() {
		log("ejbPassivate called");
	}

	public void setMessageDrivenContext(MessageDrivenContext ctx) {
		log("setMessageDrivenContext called");
		this.ctx = ctx;
	}

	public void ejbCreate() throws CreateException {
		log("ejbCreate called - This is called by the Container when deploying bean");

	}

	public void onMessage(Message msg) {
		BytesMessage map = (BytesMessage) msg;
		int bytesRead = 0;
		byte[] bytes = new byte[1024];

		log("Received Message:");

		try {
			log("----------[ File Received ]--------------");
			while ((bytesRead = map.readBytes(bytes, 1024)) > 0) {
				log(new String(bytes, 0, bytesRead));
			}
			log("----------[ File Received ]--------------");
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	private void log(String s) {
		System.out.println(s);
	}

	public void ejbActivate() {
		log("ejbActivate called");
	}

}
