package ejbs.testEntity;

import javax.ejb.CreateException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

abstract public class TestEntityBean implements EntityBean {

	final static boolean VERBOSE = true;

	private EntityContext ctx;

	public TestEntityBean() {
	};

	public void setEntityContext(EntityContext ctx) {
		log("setEntityContext called (" + id() + ")");
		this.ctx = ctx;
	}

	public void unsetEntityContext() {
		log("TestEntityBean.unsetEntityContext (" + id() + ")");
		this.ctx = null;
	}

	abstract public String getName();
	abstract public void setName(String val);

	abstract public Integer getEntityId();
	abstract public void setEntityId(Integer val);

	private String id() {
		return ""
			+ System.identityHashCode(this)
			+ ", PK = "
			+ (String) ((ctx == null)
				? "nullctx"
				: ((ctx.getPrimaryKey() == null ? "null" : ctx.getPrimaryKey().toString())));
	}

	public void ejbActivate() {
		log("TestEntityBean.ejbActivate (" + id() + ")");
	}

	public void ejbPassivate() {
		log("TestEntityBean.ejbPassivate (" + id() + ")");
	}

	public void ejbLoad() {
		log("TestEntityBean.ejbLoad (" + id() + ")");
	}

	public void ejbStore() {
		log("TestEntityBean.ejbStore (" + id() + ")");
	}

	public void ejbRemove() throws RemoveException {
		log("TestEntityBean.ejbRemove (" + id() + ")");
	}

	public Integer ejbCreate(String name) throws CreateException {
		setName(name);

		return null; // See 9.4.2 of the EJB 1.1 specification
	}

	public void ejbPostCreate(String name) {
		log("TestEntityBean.ejbPostCreate");
	}

	private void log(String s) {
		System.out.println("TestEntityBean::" + s);
	}

}
