package ejbs.testStateful;

import javax.ejb.CreateException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

public class TestStatefulBean implements SessionBean {

	private SessionContext ctx;
	private int currentCount = 0;

	private void log(String s) {
		System.out.println("TestStatefulBean::" + s);
	}

	public void ejbActivate() {
		log("ejbActivate called");
	}

	public void ejbRemove() {
		log("ejbRemove called");
	}

	public void ejbPassivate() {
		log("ejbPassivate called");
	}

	public void setSessionContext(SessionContext ctx) {
		log("setSessionContext called");
		this.ctx = ctx;
	}

	public void ejbCreate() throws CreateException {
		log("ejbCreate called");
	}

	//////////////////////////////////////////////////////////////////////////
	/**
	  <P>
	  <B>Description:</B>
	  </P>
	**/
	//////////////////////////////////////////////////////////////////////////
	public void increment() {
		currentCount++;
		log("Current Count:" + currentCount);
	}

	//////////////////////////////////////////////////////////////////////////
	/**
	  <P>
	  <B>Description:</B>
	  </P>
	**/
	//////////////////////////////////////////////////////////////////////////
	public int getCurrentCount() {
		return currentCount;
	}

}
