package tests.testStateful;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.ObjectNotFoundException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.apache.cactus.ServletTestCase;

import ejbs.testStateful.TestStateful;
import ejbs.testStateful.TestStatefulHome;

public class TestServlet extends ServletTestCase {

	public TestServlet(String theName) {
		super(theName);
	}

	public static Test suite() {
		return new TestSuite(TestServlet.class);
	}

	public void testIncrement() {
		int count = 0;

		try {
			TestStatefulHome home = lookupHome();
			TestStateful session = createSession(home);

			session.increment();
			count++;
			assertEquals(count, session.getCurrentCount());

			session.increment();
			count++;
			assertEquals(count, session.getCurrentCount());

			session.increment();
			count++;
			assertEquals(count, session.getCurrentCount());

		}
		catch (Exception e) {
			e.printStackTrace();
			fail("Failed Working with Session:" + e.getMessage());
		}

	}

	private TestStateful createSession(TestStatefulHome home)
		throws ObjectNotFoundException, CreateException, RemoteException {

		TestStateful session = null;

		log("Creating Session: ");
		session = (TestStateful) PortableRemoteObject.narrow(home.create(), TestStateful.class);

		log("Created Session: ");
		return session;
	}

	private TestStatefulHome lookupHome() throws NamingException {
		Context ctx = new InitialContext();

		log("Looking up Home:");
		TestStatefulHome home = (TestStatefulHome) ctx.lookup("testStateful");
		home = (TestStatefulHome) PortableRemoteObject.narrow(home, TestStatefulHome.class);
		return home;
	}

	private void log(String str) {
		System.out.println("TestServlet::" + str);
	}

	public static void main(String[] theArgs){
	  junit.swingui.TestRunner.main(new String[] {TestServlet.class.getName()});
	}

}
