package tests.testStateless;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.ObjectNotFoundException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import junit.framework.TestSuite;

import org.apache.cactus.ServletTestCase;

import ejbs.testStateless.TestStateless;
import ejbs.testStateless.TestStatelessHome;

public class TestServlet extends ServletTestCase {

	public TestServlet(String theName) {
		super(theName);
	}

	public static TestSuite suite() {
		return new TestSuite(TestServlet.class);
	}


	public void testPositiveResponse() {

		try {
			TestStatelessHome home = lookupHome();
			TestStateless session = createSession(home);
			boolean value = session.positiveResponse();
			assertEquals(true, value);
		}
		catch (Exception e) {
			e.printStackTrace();
			fail("Failed Finding Session:" + e.getMessage());
		}

	}


	public void testNegativeResponse() {

		try {
			TestStatelessHome home = lookupHome();
			TestStateless session = createSession(home);
			boolean value = session.negativeResponse();
			assertEquals(false, value);
		}
		catch (Exception e) {
			e.printStackTrace();
			fail("Failed Finding Session:" + e.getMessage());
		}

	}


	private TestStateless createSession(TestStatelessHome home)
		throws ObjectNotFoundException, CreateException, RemoteException {

		TestStateless session = null;

		log("Creating Session: ");
		session = (TestStateless) PortableRemoteObject.narrow(home.create(), TestStateless.class);

		log("Created Session: ");
		return session;
	}


	private TestStatelessHome lookupHome() throws NamingException {
		Context ctx = new InitialContext();

		log("Looking up Home:");
		TestStatelessHome home = (TestStatelessHome) ctx.lookup("testStateless");
		home = (TestStatelessHome) PortableRemoteObject.narrow(home, TestStatelessHome.class);
		return home;
	}


	private void log(String str) {
		System.out.println("TestServlet::" + str);
	}


	public static void main(String[] theArgs) {
		junit.swingui.TestRunner.main(new String[] { TestServlet.class.getName()});
	}

}
